from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Boolean, String, Int, File

Seqkit_Fx2Tab_V0_1_0 = CommandToolBuilder(tool="seqkit_fx2tab", base_command=["seqkit", "fx2tab"], inputs=[ToolInput(tag="in_alphabet", input_type=Boolean(optional=True), prefix="--alphabet", doc=InputDocumentation(doc="print alphabet letters")), ToolInput(tag="in_avg_qual", input_type=Boolean(optional=True), prefix="--avg-qual", doc=InputDocumentation(doc="print average quality of a read")), ToolInput(tag="in_base_content", input_type=String(optional=True), prefix="--base-content", doc=InputDocumentation(doc="print base content. (case ignored, multiple values supported) e.g. -B AT -B N")), ToolInput(tag="in_base_count", input_type=String(optional=True), prefix="--base-count", doc=InputDocumentation(doc="print base count. (case ignored, multiple values supported) e.g. -C AT -C N")), ToolInput(tag="in_case_sensitive", input_type=Boolean(optional=True), prefix="--case-sensitive", doc=InputDocumentation(doc="calculate case sensitive base content")), ToolInput(tag="in_gc", input_type=Boolean(optional=True), prefix="--gc", doc=InputDocumentation(doc="print GC content")), ToolInput(tag="in_gc_skew", input_type=Boolean(optional=True), prefix="--gc-skew", doc=InputDocumentation(doc="print GC-Skew")), ToolInput(tag="in_header_line", input_type=Boolean(optional=True), prefix="--header-line", doc=InputDocumentation(doc="print header line")), ToolInput(tag="in_length", input_type=Boolean(optional=True), prefix="--length", doc=InputDocumentation(doc="print sequence length")), ToolInput(tag="in_name", input_type=Boolean(optional=True), prefix="--name", doc=InputDocumentation(doc="only print names (no sequences and qualities)")), ToolInput(tag="in_only_id", input_type=Boolean(optional=True), prefix="--only-id", doc=InputDocumentation(doc="print ID instead of full head")), ToolInput(tag="in_qual_ascii_base", input_type=Int(optional=True), prefix="--qual-ascii-base", doc=InputDocumentation(doc="ASCII BASE, 33 for Phred+33 (default 33)")), ToolInput(tag="in_seq_hash", input_type=Boolean(optional=True), prefix="--seq-hash", doc=InputDocumentation(doc="print hash of sequence (case sensitive)")), ToolInput(tag="in_alphabet_guess_seq_length", input_type=Int(optional=True), prefix="--alphabet-guess-seq-length", doc=InputDocumentation(doc="length of sequence prefix of the first FASTA record based on which seqkit guesses the sequence type (0 for whole seq) (default 10000)")), ToolInput(tag="in_id_ncbi", input_type=Boolean(optional=True), prefix="--id-ncbi", doc=InputDocumentation(doc="FASTA head is NCBI-style, e.g. >gi|110645304|ref|NC_002516.2| Pseud...")), ToolInput(tag="in_id_regexp", input_type=String(optional=True), prefix="--id-regexp", doc=InputDocumentation(doc="regular expression for parsing ID (default '^(\\S+)\\s?')")), ToolInput(tag="in_in_file_list", input_type=File(optional=True), prefix="--infile-list", doc=InputDocumentation(doc="file of input files list (one file per line), if given, they are appended to files from cli arguments")), ToolInput(tag="in_line_width", input_type=Int(optional=True), prefix="--line-width", doc=InputDocumentation(doc="line width when outputing FASTA format (0 for no wrap) (default 60)")), ToolInput(tag="in_out_file", input_type=File(optional=True), prefix="--out-file", doc=InputDocumentation(doc="out file ('-' for stdout, suffix .gz for gzipped out) (default '-')")), ToolInput(tag="in_quiet", input_type=Boolean(optional=True), prefix="--quiet", doc=InputDocumentation(doc="be quiet and do not show extra information")), ToolInput(tag="in_seq_type", input_type=String(optional=True), prefix="--seq-type", doc=InputDocumentation(doc="sequence type (dna|rna|protein|unlimit|auto) (for auto, it automatically detect by the first sequence) (default 'auto')")), ToolInput(tag="in_threads", input_type=Int(optional=True), prefix="--threads", doc=InputDocumentation(doc="number of CPUs. (default value: 1 for single-CPU PC, 2 for others. can also set with environment variable SEQKIT_THREADS) (default 2)"))], outputs=[ToolOutput(tag="out_out_file", output_type=File(optional=True), selector=InputSelector(input_to_select="in_out_file", type_hint=File()), doc=OutputDocumentation(doc="out file ('-' for stdout, suffix .gz for gzipped out) (default '-')"))], container="quay.io/biocontainers/seqkit:0.16.0--h9ee0642_0", version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Seqkit_Fx2Tab_V0_1_0().translate("wdl")

